AutoReq: yes,noosgi
BuildRequires: rpm-build-java-osgi
BuildRequires: /proc
BuildRequires: jpackage-compat
# Copyright (c) 2000-2008, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define gcj_support 0

%define bname fop

Name:           xmlgraphics-fop
Version:        0.95
Release:        alt5_6jpp6
Epoch:          0
Summary:        XSL-driven print formatter
License:        ASL 2.0
Group:          Development/Java
# svn export http://svn.apache.org/repos/asf/xmlgraphics/fop/tags/fop-0_95/ fop-0.95
# tar cvzf fop-0.95-src.tar.gz fop-0.95
Source0:        http://www.apache.org/dist/xmlgraphics/fop/fop-0.95-src.tar.gz
Source1:        %{name}.script
Patch0:         xmlgraphics-fop-build.patch
Patch1:         xmlgraphics-fop-cli.patch
URL:            http://xmlgraphics.apache.org/fop/
Requires(post): jpackage-utils >= 0:1.7.4
Requires(postun): jpackage-utils >= 0:1.7.4
Requires: jpackage-utils >= 0:1.7.4
Requires: xmlgraphics-batik
Requires: excalibur-avalon-logkit
Requires: excalibur-avalon-framework-api
Requires: excalibur-avalon-framework-impl
Requires: xalan-j2
Requires: xerces-j2
Requires: xmlgraphics-commons
Requires: xml-commons-jaxp-1.3-apis
BuildRequires: jpackage-utils >= 0:1.7.4
BuildRequires: java-javadoc
BuildRequires: ant >= 0:1.6.5
BuildRequires: ant-trax
BuildRequires: ant-junit
BuildRequires: junit
BuildRequires: xmlgraphics-batik
BuildRequires: xmlgraphics-batik-javadoc
BuildRequires: excalibur-avalon-logkit
BuildRequires: excalibur-avalon-framework-api
BuildRequires: excalibur-avalon-framework-impl
BuildRequires: servlet_api
BuildRequires: xalan-j2
BuildRequires: xerces-j2
BuildRequires: xmlgraphics-commons >= 0:1.2
BuildRequires: xmlunit
BuildRequires: xml-commons-jaxp-1.3-apis
%if %{gcj_support}
BuildRequires: java-gcj-compat-devel
%else
BuildArch:       noarch
%endif
Source44: import.info
Source45: fop-0.95.jar-OSGi-MANIFEST.MF

Provides: fop = %{epoch}:%version-%release
Obsoletes: fop <= 0:0.21
Obsoletes: fop <= 0.21
Conflicts: fop <= 0:0.21

%description
FOP is the world's first print formatter driven by XSL formatting
objects. It is a Java application that reads a formatting object tree
and then turns it into a PDF document. The formatting object tree, can
be in the form of an XML document (output by an XSLT engine like XT or
Xalan) or can be passed in memory as a DOM Document or (in the case of
XT) SAX events.

%package        javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
BuildArch: noarch

%description    javadoc
Javadoc for %{name}.

%prep
%setup -q -n %{bname}-%{version}
find -name "*.jar" | xargs -t rm
%patch0 -p0 -b .build
%patch1 -p1 -b .cli

pushd lib
ln -s $(build-classpath excalibur/avalon-framework-api)
ln -s $(build-classpath excalibur/avalon-framework-impl)
ln -s $(build-classpath commons-io)
ln -s $(build-classpath commons-logging)
ln -s $(build-classpath servlet_api)
ln -s $(build-classpath xml-commons-jaxp-1.3-apis)
ln -s $(build-classpath xml-commons-jaxp-1.3-apis-ext)
ln -s $(build-classpath xmlgraphics-batik/anim)
ln -s $(build-classpath xmlgraphics-batik/awt-util)
ln -s $(build-classpath xmlgraphics-batik/bridge)
ln -s $(build-classpath xmlgraphics-batik/css)
ln -s $(build-classpath xmlgraphics-batik/dom)
ln -s $(build-classpath xmlgraphics-batik/ext)
ln -s $(build-classpath xmlgraphics-batik/extension)
ln -s $(build-classpath xmlgraphics-batik/gvt)
ln -s $(build-classpath xmlgraphics-batik/parser)
ln -s $(build-classpath xmlgraphics-batik/svg-dom)
ln -s $(build-classpath xmlgraphics-batik/svggen)
ln -s $(build-classpath xmlgraphics-batik/script)
ln -s $(build-classpath xmlgraphics-batik/transcoder)
ln -s $(build-classpath xmlgraphics-batik/util)
ln -s $(build-classpath xmlgraphics-batik/xml)
ln -s $(build-classpath xalan-j2)
ln -s $(build-classpath xalan-j2-serializer)
ln -s $(build-classpath xerces-j2)
ln -s $(build-classpath xmlgraphics-commons)
ln -s $(build-classpath xmlunit)
popd

%build
export CLASSPATH=
export OPT_JAR_LIST=`%{__cat} %{_sysconfdir}/ant.d/{junit,trax}`
ant -Dant.build.javac.source=1.5 -Dant.build.javac.target=1.5 \
  -Dbatik.javadoc=%{_javadocdir}/xmlgraphics-batik \
  package junit maven-artifacts

%install

# jars
mkdir -p $RPM_BUILD_ROOT%{_javadir}
install -m 644 build/%{bname}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)
%add_to_maven_depmap org.apache.xmlgraphics %{bname} %{version} JPP %{name}

# pom
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -pm 644 build/maven/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}.pom

# script
mkdir -p $RPM_BUILD_ROOT%{_bindir}
cp -p %{SOURCE1} $RPM_BUILD_ROOT%{_bindir}/xmlgraphics-fop

# data
mkdir -p $RPM_BUILD_ROOT%{_datadir}/%{name}
cp -pr hyph $RPM_BUILD_ROOT%{_datadir}/%{name}
cp -pr conf $RPM_BUILD_ROOT%{_datadir}/%{name}

# javadoc
mkdir -p $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr build/javadocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}

%if %{gcj_support}
%{_bindir}/aot-compile-rpm
%endif

# inject OSGi manifest fop-0.95.jar-OSGi-MANIFEST.MF
rm -rf META-INF
mkdir -p META-INF
cp %{SOURCE45} META-INF/MANIFEST.MF
zip -u %buildroot/usr/share/java/xmlgraphics-fop.jar META-INF/MANIFEST.MF

mkdir -p $RPM_BUILD_ROOT`dirname /etc/fop.conf`
touch $RPM_BUILD_ROOT/etc/fop.conf

# hack intil jpackage #308
# https://www.jpackage.org/bugzilla/show_bug.cgi?id=308
# will be fixed
subst 's,excalibur/avalon-framework-api,excalibur/avalon-framework-api excalibur/avalon-framework-impl,' %buildroot%_bindir/%name
subst 's,xmlgraphics-batik/util,xmlgraphics-batik,' %buildroot%_bindir/%name
# add xmlgraphics-commons to classpath
grep xmlgraphics-commons %buildroot%_bindir/xmlgraphics-fop || sed -i 's,xmlgraphics-fop xmlgraphics-batik,xmlgraphics-fop xmlgraphics-batik-all xmlgraphics-commons commons-io commons-logging,' %buildroot%_bindir/xmlgraphics-fop

# fop compat symlinks
pushd $RPM_BUILD_ROOT/%_javadir
ln -s xmlgraphics-fop.jar fop.jar
popd
pushd $RPM_BUILD_ROOT/%_bindir
ln -s xmlgraphics-fop fop
popd
pushd $RPM_BUILD_ROOT/%_datadir
ln -s xmlgraphics-fop fop
popd
# end inject OSGi manifest fop-0.95.jar-OSGi-MANIFEST.MF

%files
%doc NOTICE LICENSE README known-issues.xml status.xml

%attr(0755,root,root) %{_bindir}/xmlgraphics-fop
%{_javadir}/%{name}*.jar
%{_datadir}/%{name}
%{_datadir}/maven2/*
%{_mavendepmapfragdir}/*
%if %{gcj_support}
%dir %{_libdir}/gcj/%{name}
%{_libdir}/gcj/%{name}/%{name}-%{version}.jar.*
%endif
%config(noreplace,missingok) /etc/fop.conf
# compat symlinks
%_javadir/fop.jar
%_bindir/fop
%_datadir/fop

%files javadoc
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%changelog
* Thu Dec 16 2010 Igor Vlasenko <viy@altlinux.ru> 0:0.95-alt5_6jpp6
- added commons-logging to the classpath

* Mon Dec 06 2010 Igor Vlasenko <viy@altlinux.ru> 0:0.95-alt4_6jpp6
- add xmlgraphics-commons to classpath

* Sat Dec 04 2010 Igor Vlasenko <viy@altlinux.ru> 0:0.95-alt3_6jpp6
- added OSGi provides

* Thu May 28 2009 Igor Vlasenko <viy@altlinux.ru> 0:0.95-alt3_6jpp5
- new jpp release

* Thu Jan 29 2009 Igor Vlasenko <viy@altlinux.ru> 0:0.95-alt3_5jpp5
- obsoletes fop 0.20.5

* Tue Oct 28 2008 Igor Vlasenko <viy@altlinux.ru> 0:0.95-alt2_5jpp5
- fixed #17536

* Sat Oct 04 2008 Igor Vlasenko <viy@altlinux.ru> 0:0.95-alt1_5jpp5
- added config

* Sat Sep 06 2008 Igor Vlasenko <viy@altlinux.ru> 0:0.95-alt1_4jpp5
- converted from JPackage by jppimport script

